//---------------------------------------------------------------------------
// USBLcd.cpp
//
// Test Bitbang Mode mit einem Standard LCD-Display
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 19.02.2003
//---------------------------------------------------------------------------

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <windows.h>

#include "ftd2xx.h"
#include "ftd2def.h"
#include "lcd.h"

void CleanUp();

//**********************************************************************************
int main(int argc, char *argv[])
//**********************************************************************************
{
 DWORD numDevs;
 DWORD i;
 unsigned char by;

 if(argc<2)
  {
   printf("Please use serialnumber as parameter 1\n"
          "when calling this program.\n");
   exit(1);
  }

 if(LoadFTDLL())
  {
   if(FT_ListDevices(&numDevs,NULL,FT_LIST_NUMBER_ONLY)==FT_OK)
    {
     printf("Connected devices: %d\n\n",numDevs);

     if(FT_OpenEx(argv[1],FT_OPEN_BY_SERIAL_NUMBER,&fthandle)==FT_OK)
      {
       printf("Device Ser.Nr. %s is open.\n",argv[1]);


       ftstatus=FT_SetLatencyTimer(fthandle,1);
         if(ftstatus==FT_OK)
          {
           printf("LatencyTimer set to minimum of 1ms.\n");
          }
         else
          {
           printf("SetLatencyTimer() failed. ftstatus=0x%08X\n",ftstatus);
          }


         ftstatus=FT_SetBitMode(fthandle,(unsigned char)0xFF,(unsigned char)0x01);
         if(ftstatus==FT_OK)
          {
           printf("BitBang-Mode enabled.\n");
          }
         else
          {
           printf("SetBitMode() failed. ftstatus=0x%08X\n",ftstatus);
          }


       ftstatus=FT_ResetDevice(fthandle);
       if (ftstatus == FT_OK)
        {
         printf("Device reset.\n");
        }
       else
        {
         printf("ResetDevice() failed. ftstatus=0x%08X\n",ftstatus);
        }

       ftstatus=FT_SetBaudRate(fthandle,9600);
       if (ftstatus == FT_OK)
        {
         printf("BaudRate set.\n");
        }
       else
        {
         printf("SetBaudRate() failed. ftstatus=0x%08X\n",ftstatus);
        }

do
{

       LCDInit();
       LCDCls();
       LCDWrite("USB LCD-Display Version 1.0");
       LCDPos(2,1);
       LCDWrite("hk@holger-klabunde.de");

       Sleep(1000);

       LCDCls();
       LCDWrite("BitBang Mode");
       LCDPos(2,1);
       LCDWrite("with FT245BM");
       Sleep(1000);
}while(1);

       ftstatus=FT_SetBitMode(fthandle,(unsigned char)0xFF,(unsigned char)0x00);
       if(ftstatus==FT_OK)
        {
         printf("BitBang-Mode disabled.\n");
        }
       else
        {
         printf("SetBitMode() failed. ftstatus=0x%08X\n",ftstatus);
        }

       if(fthandle) FT_Close(fthandle);
       fthandle=NULL;
       printf("Device is closed.\n");
      }

    }//if(FT_ListDevices(&numDevs,NULL,FT_LIST_NUMBER_ONLY)==FT_OK)
   else
    {
     printf("No devices connected\n");
    }

  }

 CleanUp();
 UnloadFTDLL(); //Don't forget
 return 0;
}

//**********************************************************************************
void CleanUp() 
//**********************************************************************************
{
 if(fthandle) { FT_Close(fthandle); fthandle=NULL; }
}
